unit SigumaMatsub;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls, Vcl.Grids;

type
  TSigumaMatF = class(TForm)
    SigumaEdit: TLabeledEdit;
    Button1: TButton;
    MatSizeEdit: TLabeledEdit;
    SigumaGrid: TStringGrid;
    TotalLabel: TLabel;
    GaussSetBtn: TButton;
    procedure Button1Click(Sender: TObject);
    procedure GaussSetBtnClick(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
    procedure Gaussdisp;
  end;

var
  SigumaMatF: TSigumaMatF;

  GaussSetF :Boolean;             // }XNzɃZbgǂ̑ItO

implementation

{$R *.dfm}
uses UsMain;

var
  MatSize: integer;
  Z     : double;

function Maskdatacalc( X, Y : Integer): double;
begin
  Result := 1 / 2 / pi / Z / Z * Exp(-(X * X + Y * Y) / 2 / Z / Z);    // }XNf[^[̌vZ
end;

procedure TSigumaMatF.Button1Click(Sender: TObject);
var
  CH    : integer;
  KS    : Double;
  X, Y  : integer;
begin
  if GaussSetF then MatsizeEdit.Text := IntTostr(MatSizeIN);
  val(SigumaEdit.Text, Z, CH);
  if CH <> 0 then begin
    application.MessageBox(' ͂ɊԈႢ܂B','',0);
    exit;
  end;
  val(MatsizeEdit.Text, MatSize, CH);
  if CH <> 0 then begin
    application.MessageBox('Mat ͂ɊԈႢ܂B','',0);
    exit;
  end;
  if MatSize mod 2 = 0 then begin
    application.MessageBox('MatSize ͊łȂ΂Ȃ܂B','',0);
    exit;
  end;
  if MatSize > 11 then begin
    application.MessageBox('MatSize ͂PPȏɂȂŉB','',0);
    exit;
  end;
// XgOObh̐ݒ
  SigumaGrid.ClientWidth  := (SigumaGrid.DefaultColWidth + 1)  * (MatSize + 1) - 1;
  SigumaGrid.ColCount := MatSize + 1;
  SigumaGrid.ClientHeight := (SigumaGrid.DefaultRowHeight + 1) * (MatSize + 1) - 1;
  SigumaGrid.RowCount := MatSize + 1;
// ŒZɃio[O
  for Y := - MatSize div 2 to (MatSize div 2) do SigumaGrid.Cells[0 , Y + MatSize div 2 + 1] := intTostr(Y);
  for X := - MatSize div 2 to (MatSize div 2) do SigumaGrid.Cells[X + MatSize div 2 + 1,  0] := intTostr(X);

// ВlɂAV[v}XNf[^[vZƕ\
  Total := 0;                                             // }XNf[^[vlNA
  for Y := - MatSize div 2 to (MatSize div 2) do
    for X := - MatSize div 2 to (MatSize div 2) do begin
      KS := Maskdatacalc( X, Y);                          // }XNf[^[̃Zbg
      Total := Total + KS;                                // vlvZ
      SigumaGrid.Cells[X  + MatSize div 2 + 1, Y + MatSize div 2 + 1] := FloatTostrF(KS, ffFixed, 6,5);  // Obhɕ\
    end;

  TotalLabel.Caption := 'Total= ' + FloatTostrF(Total,ffFixed,8,5);  // vl\
  if GaussSetF then GaussSetBtn.Enabled := True;                     // vZl̃}XNZbg{^Cl[u
end;

procedure TSigumaMatF.GaussSetBtnClick(Sender: TObject);
var
  II : integer;
  X, Y: integer;
begin
  II := 0;
  for Y := - MatSize div 2 to (MatSize div 2) do
    for X := - MatSize div 2 to (MatSize div 2) do begin
      GaussianMat[II] := Maskdatacalc( X, Y);             // }XNf[^[̃Zbg
      inc(II);
    end;
  if MatSize = 11 then M11X11Siguma := Z;
  GaussDaultF := False;                                   // AV[v}XNftHglɐݒ肷tO
  MainF.GaussLabel.Caption := 'CustomGauss';
  Hide;
end;

procedure TSigumaMatF.Gaussdisp;                          // ŒKEXQl\
var
  X, Y: integer;
  II  : integer;
begin
// XgOObh̐ݒ
  GaussSetBtn.Enabled := False;
  Button1.Enabled := False;
  SigumaEdit.Visible := False;
//  SigumaEdit.Enabled := False;
  SigumaGrid.ClientWidth  := (SigumaGrid.DefaultColWidth + 1)  * (MatSizeIN + 1) - 1;
  SigumaGrid.ColCount := MatSizeIN + 1;
  SigumaGrid.ClientHeight := (SigumaGrid.DefaultRowHeight + 1) * (MatSizeIN + 1) - 1;
  SigumaGrid.RowCount := MatSizeIN + 1;
  MatsizeEdit.Text := intTostr(MatSizeIN);
// ŒZɃio[O
  for Y := - MatSizeIN div 2 to (MatSizeIN div 2) do SigumaGrid.Cells[0 , Y + MatSizeIN div 2 + 1] := intTostr(Y);
  for X := - MatSizeIN div 2 to (MatSizeIN div 2) do SigumaGrid.Cells[X + MatSizeIN div 2 + 1,  0] := intTostr(X);
// ftHg@}XNf[^[̃Zbg
  II := 0;
  Total := 0;
  for Y := 1 to MatSizeIN do
    for X := 1 to MatSizeIN do begin
      if MatSizeIN > 7 then
        SigumaGrid.Cells[X, Y] := FloatTostrF(GaussianMat[II], ffFixed, 6,5)
      else
        SigumaGrid.Cells[X, Y] := FloatTostr(GaussianMat[II]);
      Total := Total + GaussianMat[II];
      inc(II);
    end;
  TotalLabel.Caption := 'Total= ' + FloatTostrF(Total,ffFixed,8,5);  // vl\
end;


end.
